import { useEffect, useMemo } from "preact/hooks";
import { useQuery } from "react-query";
import { fetchGuildRoles } from "../../api";
import Tribute from "tributejs";
import { useGuild } from "./useGuild";

export const useMentions = (input) => {
    const guild = useGuild();

    const { data: roles } = useQuery(fetchGuildRoles(guild));

    const tribute = useMemo(() => {
        return new Tribute({
            values: (roles || []).map(({ id, name }) => ({ key: name, value: id })),
            allowSpaces: true,
            selectTemplate: (item) => {
                return `<@&${item.original.value}>`;
            },
        });
    }, [roles]);

    useEffect(() => {
        tribute.detach(input.current);
        if (input.current !== null) {
            tribute.attach(input.current);
        }
    }, [tribute]);
};
